// Example Program clcd02
// Character LCD: Solomon LM1090TGR (2 Rows x 16 Characters)
// Chin-Shiuh Shieh
// 2003-03-20

#include <AT89C51.h>
#include <string.h>

#define	CLCD_RS		P2_0
#define	CLCD_RW		P2_1
#define	CLCD_E		P2_2
#define	CLCD_Port	P1

void clcd_init(void);
void clcd_cursor(int row,int col);
void clcd_puts(char str[]);
void clcd_wait(void);
void clcd_wi(char x);
void clcd_wd(char x);

void main(void)
{
int  i;
char tmp;
char msg[17]="Hello, 8051!    ";
clcd_init();
clcd_cursor(1,0);
clcd_puts("Chin-Shiuh Shieh");
while(1)
	{
	clcd_cursor(0,0);
	clcd_puts(msg);
	for(i=-32768;i<32767;i++);
	for(i=-32768;i<32767;i++);
	tmp=msg[0];
	for(i=1;i<16;i++)
		msg[i-1]=msg[i];
	msg[15]=tmp;
	}
}

void clcd_init()
{
clcd_wi(0x38);		// 8-bit interface, 2 lines, 5x7 dots
clcd_wi(0x0F);		// display on, cursor on, cursor blinking
clcd_wi(0x06);		// move cursor right when read/write
clcd_wi(0x01);		// clear display, cursor home
}

void clcd_cursor(int row,int col)
{
int ddram=0x80;
if(row==1)
	ddram+=0x40;
ddram+=col;
clcd_wi(ddram);
}

void clcd_puts(char str[])
{
int i;
for(i=0;i<strlen(str);i++)
	clcd_wd(str[i]);
}

void clcd_wi(char x)
{
clcd_wait();
CLCD_RS=0;
CLCD_RW=0;
CLCD_Port=x;
CLCD_E=1;
CLCD_E=0;
}

void clcd_wd(char x)
{
clcd_wait();
CLCD_RS=1;
CLCD_RW=0;
CLCD_Port=x;
CLCD_E=1;
CLCD_E=0;
}

void clcd_wait(void)
{
CLCD_Port=0xFF;
CLCD_RS=0;
CLCD_RW=1;
do
	{
	CLCD_E=1;
	ACC=CLCD_Port;
	CLCD_E=0;
	}
while(ACC_7==1);
}


